/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Normal
* Screen size : <800,480>
*
*******************************************************************************/

#ifndef _ChartsDemoBarScreen_H
#define _ChartsDemoBarScreen_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_ChartsDemoBarChart.h"
#include "_CoreGroup.h"
#include "_ViewsText.h"
#include "_WidgetSetHorizontalSlider.h"
#include "_WidgetSetPushButton.h"
#include "_WidgetSetRadioButton.h"
#include "_WidgetSetToggleButton.h"

/* Forward declaration of the class ChartsDemo::BarScreen */
#ifndef _ChartsDemoBarScreen_
  EW_DECLARE_CLASS( ChartsDemoBarScreen )
#define _ChartsDemoBarScreen_
#endif

/* Forward declaration of the class Core::KeyPressHandler */
#ifndef _CoreKeyPressHandler_
  EW_DECLARE_CLASS( CoreKeyPressHandler )
#define _CoreKeyPressHandler_
#endif

/* Forward declaration of the class Core::LayoutContext */
#ifndef _CoreLayoutContext_
  EW_DECLARE_CLASS( CoreLayoutContext )
#define _CoreLayoutContext_
#endif

/* Forward declaration of the class Core::View */
#ifndef _CoreView_
  EW_DECLARE_CLASS( CoreView )
#define _CoreView_
#endif


/* The 'BarScreen' class implements a complete GUI component containing a bar chart 
   diagram and a couple of control items to configure the chart. The GUI component 
   is used within the @ChartsDemo class and embedded within an outline box in order 
   to support smooth scrolling between the screens. */
EW_DEFINE_FIELDS( ChartsDemoBarScreen, CoreGroup )
  EW_OBJECT  ( BarChart,        ChartsDemoBarChart )
  EW_OBJECT  ( SliderMaxValue,  WidgetSetHorizontalSlider )
  EW_OBJECT  ( SliderNoOfGridLines, WidgetSetHorizontalSlider )
  EW_OBJECT  ( RadioRect,       WidgetSetRadioButton )
  EW_OBJECT  ( RadioFlat,       WidgetSetRadioButton )
  EW_OBJECT  ( RadioRound,      WidgetSetRadioButton )
  EW_OBJECT  ( RadioRange,      WidgetSetRadioButton )
  EW_OBJECT  ( SliderSpacing,   WidgetSetHorizontalSlider )
  EW_OBJECT  ( CheckBoxBackground, WidgetSetToggleButton )
  EW_OBJECT  ( ActionButton1,   WidgetSetPushButton )
  EW_OBJECT  ( Caption,         ViewsText )
  EW_OBJECT  ( Text1,           ViewsText )
  EW_OBJECT  ( Text2,           ViewsText )
  EW_OBJECT  ( Text3,           ViewsText )
  EW_ARRAY   ( Values,          XFloat, [24])
  EW_ARRAY   ( Colors,          XColor, [24])
EW_END_OF_FIELDS( ChartsDemoBarScreen )

/* Virtual Method Table (VMT) for the class : 'ChartsDemo::BarScreen' */
EW_DEFINE_METHODS( ChartsDemoBarScreen, CoreGroup )
  EW_METHOD( initLayoutContext, void )( CoreRectView _this, XRect aBounds, CoreOutline 
    aOutline )
  EW_METHOD( GetRoot,           CoreRoot )( CoreView _this )
  EW_METHOD( Draw,              void )( CoreGroup _this, GraphicsCanvas aCanvas, 
    XRect aClip, XPoint aOffset, XInt32 aOpacity, XBool aBlend )
  EW_METHOD( GetClipping,       XRect )( CoreGroup _this )
  EW_METHOD( HandleEvent,       XObject )( CoreView _this, CoreEvent aEvent )
  EW_METHOD( CursorHitTest,     CoreCursorHit )( CoreGroup _this, XRect aArea, XInt32 
    aFinger, XInt32 aStrikeCount, CoreView aDedicatedView, CoreView aStartView, 
    XSet aRetargetReason )
  EW_METHOD( AdjustDrawingArea, XRect )( CoreGroup _this, XRect aArea )
  EW_METHOD( ArrangeView,       XPoint )( CoreRectView _this, XRect aBounds, XEnum 
    aFormation )
  EW_METHOD( MoveView,          void )( CoreRectView _this, XPoint aOffset, XBool 
    aFastMove )
  EW_METHOD( GetExtent,         XRect )( CoreRectView _this )
  EW_METHOD( ChangeViewState,   void )( CoreGroup _this, XSet aSetState, XSet aClearState )
  EW_METHOD( OnSetBounds,       void )( CoreGroup _this, XRect value )
  EW_METHOD( OnSetFocus,        void )( CoreGroup _this, CoreView value )
  EW_METHOD( DispatchEvent,     XObject )( CoreGroup _this, CoreEvent aEvent )
  EW_METHOD( BroadcastEvent,    XObject )( CoreGroup _this, CoreEvent aEvent, XSet 
    aFilter )
  EW_METHOD( UpdateLayout,      void )( CoreGroup _this, XPoint aSize )
  EW_METHOD( UpdateViewState,   void )( CoreGroup _this, XSet aState )
  EW_METHOD( InvalidateArea,    void )( CoreGroup _this, XRect aArea )
EW_END_OF_METHODS( ChartsDemoBarScreen )

/* This method is invoked by the PieChart object when the object updates a slice. 
   It provides data (value and color) for the affected slice. */
void ChartsDemoBarScreen_onLoadValue( ChartsDemoBarScreen _this, XObject sender );

/* Slot method to scale the chart content. */
void ChartsDemoBarScreen_RangeSlot( ChartsDemoBarScreen _this, XObject sender );

/* Slot method to switch on/off the charts background. */
void ChartsDemoBarScreen_BackgroundSlot( ChartsDemoBarScreen _this, XObject sender );

/* Slot method to rotate the chart content. */
void ChartsDemoBarScreen_OrientationSlot( ChartsDemoBarScreen _this, XObject sender );

/* Slot method to create a set of random records - used as data source for the chart 
   diagram. */
void ChartsDemoBarScreen_RandomRecords( ChartsDemoBarScreen _this, XObject sender );

#ifdef __cplusplus
  }
#endif

#endif /* _ChartsDemoBarScreen_H */

/* Embedded Wizard */
