/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Normal
* Screen size : <800,480>
*
*******************************************************************************/

#ifndef _ChartsDemoLineChart_H
#define _ChartsDemoLineChart_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_CoreOutline.h"
#include "_GraphicsPath.h"
#include "_TemplatesLineChart.h"
#include "_ViewsFillPath.h"
#include "_ViewsLine.h"
#include "_ViewsRectangle.h"
#include "_ViewsStrokePath.h"

/* Forward declaration of the class ChartsDemo::LineChart */
#ifndef _ChartsDemoLineChart_
  EW_DECLARE_CLASS( ChartsDemoLineChart )
#define _ChartsDemoLineChart_
#endif

/* Forward declaration of the class Core::Group */
#ifndef _CoreGroup_
  EW_DECLARE_CLASS( CoreGroup )
#define _CoreGroup_
#endif

/* Forward declaration of the class Core::KeyPressHandler */
#ifndef _CoreKeyPressHandler_
  EW_DECLARE_CLASS( CoreKeyPressHandler )
#define _CoreKeyPressHandler_
#endif

/* Forward declaration of the class Core::LayoutContext */
#ifndef _CoreLayoutContext_
  EW_DECLARE_CLASS( CoreLayoutContext )
#define _CoreLayoutContext_
#endif

/* Forward declaration of the class Core::View */
#ifndef _CoreView_
  EW_DECLARE_CLASS( CoreView )
#define _CoreView_
#endif

/* Forward declaration of the class Resources::Bitmap */
#ifndef _ResourcesBitmap_
  EW_DECLARE_CLASS( ResourcesBitmap )
#define _ResourcesBitmap_
#endif


/* This class implements the ChartsDemo::LineChart component. This component is 
   intended to display a line chart diagram composed of points connected by straight 
   line segments.
   The total number of points is determined by the property @NoOfValues. The corresponding 
   data is loaded dynamically at the runtime. For this purpose a slot method has 
   to be implemented and assigned to the @OnLoadValue property. The component will 
   invoke the slot method automatically each time it needs a data value to be loaded. 
   Within the slot method the implementation can access and initialize the affected 
   value by using the variables @Value, @Color and @Frame.
   To configure the color and the width of the line segments use the properties 
   @LineColor and @LineWidth. The appearance of the points is determined by the 
   property @PointBitmap. The property @FillColor configures the color to fill the 
   background of the chart. The property @Orientation, in turn, allows the chart 
   contents to appear rotated. Accordingly, the diagram can be aligned at the top, 
   left or right edge of the component.
   In order to trigger the chart component to reload one or more points, invoke 
   the method @InvalidateValues(). The component will thereupon schedule the necessary 
   loading steps automatically. */
EW_DEFINE_FIELDS( ChartsDemoLineChart, TemplatesLineChart )
  EW_OBJECT  ( fillPathData,    GraphicsPath )
  EW_OBJECT  ( strokePathData,  GraphicsPath )
  EW_OBJECT  ( Background,      ViewsRectangle )
  EW_OBJECT  ( GridLine1,       ViewsLine )
  EW_OBJECT  ( GridLine2,       ViewsLine )
  EW_OBJECT  ( GridLine3,       ViewsLine )
  EW_OBJECT  ( GridLine4,       ViewsLine )
  EW_OBJECT  ( GridLine5,       ViewsLine )
  EW_OBJECT  ( GridLine6,       ViewsLine )
  EW_OBJECT  ( GridLine7,       ViewsLine )
  EW_OBJECT  ( GridLine8,       ViewsLine )
  EW_OBJECT  ( GridLine9,       ViewsLine )
  EW_OBJECT  ( GridLine10,      ViewsLine )
  EW_OBJECT  ( FillPath,        ViewsFillPath )
  EW_OBJECT  ( StrokePath,      ViewsStrokePath )
  EW_OBJECT  ( Outline,         CoreOutline )
  EW_ARRAY   ( gridLines,       ViewsLine, [10])
  EW_PROPERTY( PointBitmap,     ResourcesBitmap )
  EW_PROPERTY( OnLoadValue,     XSlot )
  EW_VARIABLE( size,            XPoint )
  EW_VARIABLE( invalidLastValue, XInt32 )
  EW_VARIABLE( invalidFirstValue, XInt32 )
  EW_VARIABLE( Frame,           XInt32 )
  EW_VARIABLE( Color,           XColor )
  EW_VARIABLE( Value,           XFloat )
  EW_VARIABLE( Index,           XInt32 )
  EW_PROPERTY( GridLineColor,   XColor )
  EW_PROPERTY( NoOfGridLines,   XInt32 )
  EW_PROPERTY( BackColor,       XColor )
  EW_PROPERTY( Orientation,     XEnum )
  EW_PROPERTY( FillColor,       XColor )
  EW_PROPERTY( LineWidth,       XInt32 )
  EW_PROPERTY( LineColor,       XColor )
  EW_PROPERTY( NoOfValues,      XInt32 )
EW_END_OF_FIELDS( ChartsDemoLineChart )

/* Virtual Method Table (VMT) for the class : 'ChartsDemo::LineChart' */
EW_DEFINE_METHODS( ChartsDemoLineChart, TemplatesLineChart )
  EW_METHOD( initLayoutContext, void )( CoreRectView _this, XRect aBounds, CoreOutline 
    aOutline )
  EW_METHOD( GetRoot,           CoreRoot )( CoreView _this )
  EW_METHOD( Draw,              void )( CoreGroup _this, GraphicsCanvas aCanvas, 
    XRect aClip, XPoint aOffset, XInt32 aOpacity, XBool aBlend )
  EW_METHOD( GetClipping,       XRect )( CoreGroup _this )
  EW_METHOD( HandleEvent,       XObject )( CoreView _this, CoreEvent aEvent )
  EW_METHOD( CursorHitTest,     CoreCursorHit )( CoreGroup _this, XRect aArea, XInt32 
    aFinger, XInt32 aStrikeCount, CoreView aDedicatedView, CoreView aStartView, 
    XSet aRetargetReason )
  EW_METHOD( AdjustDrawingArea, XRect )( CoreGroup _this, XRect aArea )
  EW_METHOD( ArrangeView,       XPoint )( CoreRectView _this, XRect aBounds, XEnum 
    aFormation )
  EW_METHOD( MoveView,          void )( CoreRectView _this, XPoint aOffset, XBool 
    aFastMove )
  EW_METHOD( GetExtent,         XRect )( CoreRectView _this )
  EW_METHOD( ChangeViewState,   void )( CoreGroup _this, XSet aSetState, XSet aClearState )
  EW_METHOD( OnSetBounds,       void )( CoreGroup _this, XRect value )
  EW_METHOD( OnSetFocus,        void )( CoreGroup _this, CoreView value )
  EW_METHOD( DispatchEvent,     XObject )( CoreGroup _this, CoreEvent aEvent )
  EW_METHOD( BroadcastEvent,    XObject )( CoreGroup _this, CoreEvent aEvent, XSet 
    aFilter )
  EW_METHOD( UpdateLayout,      void )( ChartsDemoLineChart _this, XPoint aSize )
  EW_METHOD( UpdateViewState,   void )( CoreGroup _this, XSet aState )
  EW_METHOD( InvalidateArea,    void )( CoreGroup _this, XRect aArea )
EW_END_OF_METHODS( ChartsDemoLineChart )

/* The method UpdateLayout() is invoked automatically after the size of the component 
   has been changed. This method can be overridden and filled with logic to perform 
   a sophisticated arrangement calculation for one or more enclosed views. In this 
   case the parameter aSize can be used. It contains the current size of the component. 
   Usually, all enclosed views are arranged automatically accordingly to their @Layout 
   property. UpdateLayout() gives the derived components a chance to extend this 
   automatism by a user defined algorithm. */
void ChartsDemoLineChart_UpdateLayout( ChartsDemoLineChart _this, XPoint aSize );

/* This slot method takes care of preparing a new bitmap in GridBitmap object. This 
   bitmap is then used to draw the grid. */
void ChartsDemoLineChart_updateGrid( ChartsDemoLineChart _this, XObject sender );

/* The method 'updateChart' takes care of creating and displaying the lines and 
   points. In this template, the points are represented by Views::Image instances. 
   Consequently, if the chart is configured with @NoOfValues = 12, the method 'updateChart' 
   will manage 12 images. */
void ChartsDemoLineChart_updateChart( ChartsDemoLineChart _this, XObject sender );

/* 'C' function for method : 'ChartsDemo::LineChart.OnSetGridLineColor()' */
void ChartsDemoLineChart_OnSetGridLineColor( ChartsDemoLineChart _this, XColor value );

/* 'C' function for method : 'ChartsDemo::LineChart.OnSetNoOfGridLines()' */
void ChartsDemoLineChart_OnSetNoOfGridLines( ChartsDemoLineChart _this, XInt32 value );

/* 'C' function for method : 'ChartsDemo::LineChart.OnSetBackColor()' */
void ChartsDemoLineChart_OnSetBackColor( ChartsDemoLineChart _this, XColor value );

/* 'C' function for method : 'ChartsDemo::LineChart.OnSetOrientation()' */
void ChartsDemoLineChart_OnSetOrientation( ChartsDemoLineChart _this, XEnum value );

/* 'C' function for method : 'ChartsDemo::LineChart.OnSetFillColor()' */
void ChartsDemoLineChart_OnSetFillColor( ChartsDemoLineChart _this, XColor value );

/* 'C' function for method : 'ChartsDemo::LineChart.OnSetLineWidth()' */
void ChartsDemoLineChart_OnSetLineWidth( ChartsDemoLineChart _this, XInt32 value );

/* 'C' function for method : 'ChartsDemo::LineChart.OnSetLineColor()' */
void ChartsDemoLineChart_OnSetLineColor( ChartsDemoLineChart _this, XColor value );

/* 'C' function for method : 'ChartsDemo::LineChart.OnSetPointBitmap()' */
void ChartsDemoLineChart_OnSetPointBitmap( ChartsDemoLineChart _this, ResourcesBitmap 
  value );

/* 'C' function for method : 'ChartsDemo::LineChart.OnSetNoOfValues()' */
void ChartsDemoLineChart_OnSetNoOfValues( ChartsDemoLineChart _this, XInt32 value );

/* The method InvalidateValues() forces the chart component to reload the values 
   for one or more point. The index of the point to start the reload operation is 
   specified in the parameter aFirstValue. The parameter aLastValue specifies the 
   index of the last affected point. The first value (first point) has the index 
   0, the second 1, and so far. The operation can cause the chart component to invoke 
   the external @OnLoadValue slot method for each affected point. */
void ChartsDemoLineChart_InvalidateValues( ChartsDemoLineChart _this, XInt32 aFirstValue, 
  XInt32 aLastValue );

/* Default onget method for the property 'NoOfGridLines' */
XInt32 ChartsDemoLineChart_OnGetNoOfGridLines( ChartsDemoLineChart _this );

/* Default onget method for the property 'LineWidth' */
XInt32 ChartsDemoLineChart_OnGetLineWidth( ChartsDemoLineChart _this );

#ifdef __cplusplus
  }
#endif

#endif /* _ChartsDemoLineChart_H */

/* Embedded Wizard */
