/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Normal
* Screen size : <800,480>
*
*******************************************************************************/

#ifndef _ChartsDemoPieChart_H
#define _ChartsDemoPieChart_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_CoreOutline.h"
#include "_TemplatesPieChart.h"

/* Forward declaration of the class ChartsDemo::PieChart */
#ifndef _ChartsDemoPieChart_
  EW_DECLARE_CLASS( ChartsDemoPieChart )
#define _ChartsDemoPieChart_
#endif

/* Forward declaration of the class Core::Group */
#ifndef _CoreGroup_
  EW_DECLARE_CLASS( CoreGroup )
#define _CoreGroup_
#endif

/* Forward declaration of the class Core::KeyPressHandler */
#ifndef _CoreKeyPressHandler_
  EW_DECLARE_CLASS( CoreKeyPressHandler )
#define _CoreKeyPressHandler_
#endif

/* Forward declaration of the class Core::LayoutContext */
#ifndef _CoreLayoutContext_
  EW_DECLARE_CLASS( CoreLayoutContext )
#define _CoreLayoutContext_
#endif

/* Forward declaration of the class Core::View */
#ifndef _CoreView_
  EW_DECLARE_CLASS( CoreView )
#define _CoreView_
#endif


/* This class implements the ChartsDemo::PieChart component. This component is intended 
   to display a pie chart diagram composed of slices.
   The total number of slices is determined by the property @NoOfValues. The corresponding 
   data is loaded dynamically at the runtime. For this purpose a slot method has 
   to be implemented and assigned to the @OnLoadValue property. The component will 
   invoke the slot method automatically each time it needs a slice to be loaded. 
   Within the slot method the implementation can access and initialize the affected 
   slice by using the variables @Value and @Color.
   The property @Displacement specifies an optional displacement to move the slices 
   away from the center of the chart. The property @StartAngle specifies the angle 
   to start the first slice.
   In order to trigger the chart component to reload one or more slices, invoke 
   the method @InvalidateValues(). The component will thereupon schedule the necessary 
   loading steps automatically. */
EW_DEFINE_FIELDS( ChartsDemoPieChart, TemplatesPieChart )
  EW_OBJECT  ( Outline,         CoreOutline )
  EW_PROPERTY( OnLoadValue,     XSlot )
  EW_VARIABLE( size,            XPoint )
  EW_VARIABLE( invalidLastValue, XInt32 )
  EW_VARIABLE( invalidFirstValue, XInt32 )
  EW_VARIABLE( Color,           XColor )
  EW_VARIABLE( Value,           XFloat )
  EW_VARIABLE( Index,           XInt32 )
  EW_PROPERTY( Scaling,         XFloat )
  EW_PROPERTY( PieAngle,        XInt32 )
  EW_PROPERTY( StartAngle,      XInt32 )
  EW_PROPERTY( Displacement,    XInt32 )
  EW_PROPERTY( NoOfValues,      XInt32 )
EW_END_OF_FIELDS( ChartsDemoPieChart )

/* Virtual Method Table (VMT) for the class : 'ChartsDemo::PieChart' */
EW_DEFINE_METHODS( ChartsDemoPieChart, TemplatesPieChart )
  EW_METHOD( initLayoutContext, void )( CoreRectView _this, XRect aBounds, CoreOutline 
    aOutline )
  EW_METHOD( GetRoot,           CoreRoot )( CoreView _this )
  EW_METHOD( Draw,              void )( CoreGroup _this, GraphicsCanvas aCanvas, 
    XRect aClip, XPoint aOffset, XInt32 aOpacity, XBool aBlend )
  EW_METHOD( GetClipping,       XRect )( CoreGroup _this )
  EW_METHOD( HandleEvent,       XObject )( CoreView _this, CoreEvent aEvent )
  EW_METHOD( CursorHitTest,     CoreCursorHit )( CoreGroup _this, XRect aArea, XInt32 
    aFinger, XInt32 aStrikeCount, CoreView aDedicatedView, CoreView aStartView, 
    XSet aRetargetReason )
  EW_METHOD( AdjustDrawingArea, XRect )( CoreGroup _this, XRect aArea )
  EW_METHOD( ArrangeView,       XPoint )( CoreRectView _this, XRect aBounds, XEnum 
    aFormation )
  EW_METHOD( MoveView,          void )( CoreRectView _this, XPoint aOffset, XBool 
    aFastMove )
  EW_METHOD( GetExtent,         XRect )( CoreRectView _this )
  EW_METHOD( ChangeViewState,   void )( CoreGroup _this, XSet aSetState, XSet aClearState )
  EW_METHOD( OnSetBounds,       void )( CoreGroup _this, XRect value )
  EW_METHOD( OnSetFocus,        void )( CoreGroup _this, CoreView value )
  EW_METHOD( DispatchEvent,     XObject )( CoreGroup _this, CoreEvent aEvent )
  EW_METHOD( BroadcastEvent,    XObject )( CoreGroup _this, CoreEvent aEvent, XSet 
    aFilter )
  EW_METHOD( UpdateLayout,      void )( ChartsDemoPieChart _this, XPoint aSize )
  EW_METHOD( UpdateViewState,   void )( CoreGroup _this, XSet aState )
  EW_METHOD( InvalidateArea,    void )( CoreGroup _this, XRect aArea )
EW_END_OF_METHODS( ChartsDemoPieChart )

/* The method UpdateLayout() is invoked automatically after the size of the component 
   has been changed. This method can be overridden and filled with logic to perform 
   a sophisticated arrangement calculation for one or more enclosed views. In this 
   case the parameter aSize can be used. It contains the current size of the component. 
   Usually, all enclosed views are arranged automatically accordingly to their @Layout 
   property. UpdateLayout() gives the derived components a chance to extend this 
   automatism by a user defined algorithm. */
void ChartsDemoPieChart_UpdateLayout( ChartsDemoPieChart _this, XPoint aSize );

/* The method 'updateChart' takes care of creating and displaying the slices. In 
   this template, the slices are represented by Views::FilledPath instances. Consequently, 
   if the chart is configured with @NoOfValues = 12, the method 'updateChart' will 
   manage 12 filled path views. */
void ChartsDemoPieChart_updateChart( ChartsDemoPieChart _this, XObject sender );

/* 'C' function for method : 'ChartsDemo::PieChart.OnSetScaling()' */
void ChartsDemoPieChart_OnSetScaling( ChartsDemoPieChart _this, XFloat value );

/* 'C' function for method : 'ChartsDemo::PieChart.OnSetPieAngle()' */
void ChartsDemoPieChart_OnSetPieAngle( ChartsDemoPieChart _this, XInt32 value );

/* 'C' function for method : 'ChartsDemo::PieChart.OnSetStartAngle()' */
void ChartsDemoPieChart_OnSetStartAngle( ChartsDemoPieChart _this, XInt32 value );

/* 'C' function for method : 'ChartsDemo::PieChart.OnSetDisplacement()' */
void ChartsDemoPieChart_OnSetDisplacement( ChartsDemoPieChart _this, XInt32 value );

/* 'C' function for method : 'ChartsDemo::PieChart.OnSetNoOfValues()' */
void ChartsDemoPieChart_OnSetNoOfValues( ChartsDemoPieChart _this, XInt32 value );

/* The method InvalidateValues() forces the chart component to reload the values 
   for one or more slices. The index of the slice to start the reload operation 
   is specified in the parameter aFirstValue. The parameter aLastValue specifies 
   the index of the last affected slice. The first value (first slice) has the index 
   0, the second 1, and so far. The operation can cause the chart component to invoke 
   the external @OnLoadValue slot method for each affected slice. */
void ChartsDemoPieChart_InvalidateValues( ChartsDemoPieChart _this, XInt32 aFirstValue, 
  XInt32 aLastValue );

/* Default onget method for the property 'PieAngle' */
XInt32 ChartsDemoPieChart_OnGetPieAngle( ChartsDemoPieChart _this );

/* Default onget method for the property 'StartAngle' */
XInt32 ChartsDemoPieChart_OnGetStartAngle( ChartsDemoPieChart _this );

/* Default onget method for the property 'Displacement' */
XInt32 ChartsDemoPieChart_OnGetDisplacement( ChartsDemoPieChart _this );

#ifdef __cplusplus
  }
#endif

#endif /* _ChartsDemoPieChart_H */

/* Embedded Wizard */
