/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Normal
* Screen size : <800,480>
*
*******************************************************************************/

#ifndef _ChartsDemoPieScreen_H
#define _ChartsDemoPieScreen_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_ChartsDemoPieChart.h"
#include "_CoreGroup.h"
#include "_ViewsText.h"
#include "_WidgetSetHorizontalSlider.h"

/* Forward declaration of the class ChartsDemo::PieScreen */
#ifndef _ChartsDemoPieScreen_
  EW_DECLARE_CLASS( ChartsDemoPieScreen )
#define _ChartsDemoPieScreen_
#endif

/* Forward declaration of the class Core::KeyPressHandler */
#ifndef _CoreKeyPressHandler_
  EW_DECLARE_CLASS( CoreKeyPressHandler )
#define _CoreKeyPressHandler_
#endif

/* Forward declaration of the class Core::LayoutContext */
#ifndef _CoreLayoutContext_
  EW_DECLARE_CLASS( CoreLayoutContext )
#define _CoreLayoutContext_
#endif

/* Forward declaration of the class Core::View */
#ifndef _CoreView_
  EW_DECLARE_CLASS( CoreView )
#define _CoreView_
#endif


/* The 'PieScreen' class implements a complete GUI component containing a pie chart 
   diagram and a couple of control items to configure the chart. The GUI component 
   is used within the @ChartsDemo class and embedded within an outline box in order 
   to support smooth scrolling between the screens. */
EW_DEFINE_FIELDS( ChartsDemoPieScreen, CoreGroup )
  EW_OBJECT  ( PieChart,        ChartsDemoPieChart )
  EW_OBJECT  ( SliderStartAngle, WidgetSetHorizontalSlider )
  EW_OBJECT  ( SliderPieAngle,  WidgetSetHorizontalSlider )
  EW_OBJECT  ( SliderScaling,   WidgetSetHorizontalSlider )
  EW_OBJECT  ( SliderDisplacement, WidgetSetHorizontalSlider )
  EW_OBJECT  ( Caption,         ViewsText )
  EW_OBJECT  ( Text1,           ViewsText )
  EW_OBJECT  ( Text2,           ViewsText )
  EW_OBJECT  ( Text3,           ViewsText )
  EW_OBJECT  ( Text4,           ViewsText )
  EW_VARIABLE( ScaleFactor,     XFloat )
  EW_ARRAY   ( Colors,          XColor, [24])
  EW_ARRAY   ( Values,          XFloat, [24])
EW_END_OF_FIELDS( ChartsDemoPieScreen )

/* Virtual Method Table (VMT) for the class : 'ChartsDemo::PieScreen' */
EW_DEFINE_METHODS( ChartsDemoPieScreen, CoreGroup )
  EW_METHOD( initLayoutContext, void )( CoreRectView _this, XRect aBounds, CoreOutline 
    aOutline )
  EW_METHOD( GetRoot,           CoreRoot )( CoreView _this )
  EW_METHOD( Draw,              void )( CoreGroup _this, GraphicsCanvas aCanvas, 
    XRect aClip, XPoint aOffset, XInt32 aOpacity, XBool aBlend )
  EW_METHOD( GetClipping,       XRect )( CoreGroup _this )
  EW_METHOD( HandleEvent,       XObject )( CoreView _this, CoreEvent aEvent )
  EW_METHOD( CursorHitTest,     CoreCursorHit )( CoreGroup _this, XRect aArea, XInt32 
    aFinger, XInt32 aStrikeCount, CoreView aDedicatedView, CoreView aStartView, 
    XSet aRetargetReason )
  EW_METHOD( AdjustDrawingArea, XRect )( CoreGroup _this, XRect aArea )
  EW_METHOD( ArrangeView,       XPoint )( CoreRectView _this, XRect aBounds, XEnum 
    aFormation )
  EW_METHOD( MoveView,          void )( CoreRectView _this, XPoint aOffset, XBool 
    aFastMove )
  EW_METHOD( GetExtent,         XRect )( CoreRectView _this )
  EW_METHOD( ChangeViewState,   void )( CoreGroup _this, XSet aSetState, XSet aClearState )
  EW_METHOD( OnSetBounds,       void )( CoreGroup _this, XRect value )
  EW_METHOD( OnSetFocus,        void )( CoreGroup _this, CoreView value )
  EW_METHOD( DispatchEvent,     XObject )( CoreGroup _this, CoreEvent aEvent )
  EW_METHOD( BroadcastEvent,    XObject )( CoreGroup _this, CoreEvent aEvent, XSet 
    aFilter )
  EW_METHOD( UpdateLayout,      void )( CoreGroup _this, XPoint aSize )
  EW_METHOD( UpdateViewState,   void )( CoreGroup _this, XSet aState )
  EW_METHOD( InvalidateArea,    void )( CoreGroup _this, XRect aArea )
EW_END_OF_METHODS( ChartsDemoPieScreen )

/* This method is invoked by the PieChart object when the object updates a slice. 
   It provides data (value and color) for the affected slice. */
void ChartsDemoPieScreen_onLoadValue( ChartsDemoPieScreen _this, XObject sender );

/* Slot method to provide the current user settings to the pie chart diagram. */
void ChartsDemoPieScreen_UpdatePieSlot( ChartsDemoPieScreen _this, XObject sender );

/* Slot method to create a set of random data sets and stores them in the arrays 
   'Values' and 'Colors'. These arrays are thereupon used when the chart diagram 
   loads data. */
void ChartsDemoPieScreen_RandomRecords( ChartsDemoPieScreen _this, XObject sender );

#ifdef __cplusplus
  }
#endif

#endif /* _ChartsDemoPieScreen_H */

/* Embedded Wizard */
